--- php-8.4.18/.github/matrix.php	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/.github/matrix.php	2026-04-01 04:35:35.981455755 +0000
@@ -0,0 +1,203 @@
+<?php
+
+const BRANCHES = [
+    ['name' => 'master', 'ref' => 'master', 'version' => [8, 6]],
+    ['name' => 'PHP-8.5', 'ref' => 'PHP-8.5', 'version' => [8, 5]],
+    ['name' => 'PHP-8.4', 'ref' => 'PHP-8.4', 'version' => [8, 4]],
+    ['name' => 'PHP-8.3', 'ref' => 'PHP-8.3', 'version' => [8, 3]],
+    ['name' => 'PHP-8.2', 'ref' => 'PHP-8.2', 'version' => [8, 2]],
+];
+
+function get_branch_commit_cache_file_path(): string {
+    return dirname(__DIR__) . '/branch-commit-cache.json';
+}
+
+function get_branches() {
+    $branch_commit_cache_file = get_branch_commit_cache_file_path();
+    $branch_commit_map = [];
+    if (file_exists($branch_commit_cache_file)) {
+        $branch_commit_map = json_decode(file_get_contents($branch_commit_cache_file), JSON_THROW_ON_ERROR);
+    }
+
+    $changed_branches = [];
+    foreach (BRANCHES as $branch) {
+        $previous_commit_hash = $branch_commit_map[$branch['ref']] ?? null;
+        $current_commit_hash = trim(shell_exec('git rev-parse origin/' . $branch['ref']));
+
+        if ($previous_commit_hash !== $current_commit_hash) {
+            $changed_branches[] = $branch;
+        }
+
+        $branch_commit_map[$branch['ref']] = $current_commit_hash;
+    }
+
+    file_put_contents($branch_commit_cache_file, json_encode($branch_commit_map));
+
+    return $changed_branches;
+}
+
+function get_current_version(): array {
+    $file = dirname(__DIR__) . '/main/php_version.h';
+    $content = file_get_contents($file);
+    preg_match('(^#define PHP_MAJOR_VERSION (?<num>\d+)$)m', $content, $matches);
+    $major = (int) $matches['num'];
+    preg_match('(^#define PHP_MINOR_VERSION (?<num>\d+)$)m', $content, $matches);
+    $minor = (int) $matches['num'];
+    return [$major, $minor];
+}
+
+function select_jobs($repository, $trigger, $nightly, $labels, $php_version, $ref, $all_variations) {
+    $no_jobs = in_array('CI: No jobs', $labels, true);
+    $all_jobs = in_array('CI: All jobs', $labels, true) || $nightly;
+    $test_alpine = in_array('CI: Alpine', $labels, true);
+    $test_benchmarking = in_array('CI: Benchmarking', $labels, true);
+    $test_community = in_array('CI: Community', $labels, true);
+    $test_coverage = in_array('CI: Coverage', $labels, true);
+    $test_freebsd = in_array('CI: FreeBSD', $labels, true);
+    $test_libmysqlclient = in_array('CI: libmysqlclient', $labels, true);
+    $test_linux_ppc64 = in_array('CI: Linux PPC64', $labels, true);
+    $test_linux_x32 = in_array('CI: Linux X32', $labels, true);
+    $test_linux_x64 = in_array('CI: Linux X64', $labels, true);
+    $test_macos = in_array('CI: macOS', $labels, true);
+    $test_msan = in_array('CI: MSAN', $labels, true);
+    $test_opcache_variation = in_array('CI: Opcache Variation', $labels, true);
+    $test_pecl = in_array('CI: PECL', $labels, true);
+    $test_solaris = in_array('CI: Solaris', $labels, true);
+    $test_windows = in_array('CI: Windows', $labels, true);
+
+    $jobs = [];
+    if (version_compare($php_version, '8.4', '>=') && ($all_jobs || !$no_jobs || $test_alpine)) {
+        $jobs['ALPINE'] = true;
+    }
+    if (version_compare($php_version, '8.4', '>=')
+        && !$nightly
+        && ($all_jobs || !$no_jobs || $test_benchmarking)
+        // push trigger is restricted to official repository.
+        && ($repository === 'php/php-src' || $trigger === 'pull_request')) {
+        $jobs['BENCHMARKING']['config']['integrated_opcache'] = version_compare($php_version, '8.5', '>=');
+    }
+    if ($all_jobs || $test_community) {
+        $jobs['COMMUNITY']['matrix'] = version_compare($php_version, '8.4', '>=')
+            ? ['type' => ['asan', 'verify_type_inference']]
+            : ['type' => ['asan']];
+        $jobs['COMMUNITY']['config']['symfony_version'] = match (true) {
+            version_compare($php_version, '8.3', '<=') => '7.4',
+            default => '',
+        };
+        $jobs['COMMUNITY']['config']['laravel_version'] = match (true) {
+            version_compare($php_version, '8.2', '<=') => '12.x',
+            default => '',
+        };
+    }
+    if (($all_jobs && $ref === 'master') || $test_coverage) {
+        $jobs['COVERAGE'] = true;
+    }
+    if ($all_jobs || $test_libmysqlclient) {
+        $jobs['LIBMYSQLCLIENT'] = true;
+    }
+    if (version_compare($php_version, '8.4', '>=') && ($all_jobs || $test_linux_ppc64)) {
+        $jobs['LINUX_PPC64'] = true;
+    }
+    if ($all_jobs || !$no_jobs || $test_linux_x64) {
+        $jobs['LINUX_X64']['matrix'] = $all_variations
+            ? [
+                'name' => [''],
+                'asan' => [false],
+                'debug' => [true, false],
+                'repeat' => [false],
+                'variation' => [false],
+                'zts' => [true, false],
+                'include' => [
+                    ['name' => '_ASAN', 'asan' => true, 'debug' => true, 'repeat' => false, 'variation' => false, 'zts' => true],
+                    ['name' => '_REPEAT', 'asan' => false, 'debug' => true, 'repeat' => true, 'variation' => false, 'zts' => false],
+                    ['name' => '_VARIATION', 'asan' => false, 'debug' => true, 'repeat' => false, 'variation' => true, 'zts' => true],
+                ],
+            ]
+            : ['include' => [
+                ['name' => '', 'asan' => false, 'debug' => false, 'repeat' => false, 'variation' => false, 'zts' => false],
+                ['name' => '_ASAN', 'asan' => true, 'debug' => true, 'repeat' => false, 'variation' => false, 'zts' => true],
+            ]];
+        $jobs['LINUX_X64']['config']['variation_enable_zend_max_execution_timers'] = version_compare($php_version, '8.3', '>=');
+    }
+    if ($all_jobs || !$no_jobs || $test_linux_x32) {
+        $jobs['LINUX_X32']['matrix'] = $all_variations
+            ? ['debug' => [true, false], 'zts' => [true, false]]
+            : ['debug' => [true], 'zts' => [true]];
+    }
+    if ($all_jobs || !$no_jobs || $test_macos) {
+        $test_arm = version_compare($php_version, '8.4', '>=');
+        $jobs['MACOS']['matrix'] = $all_variations
+            ? ['arch' => $test_arm ? ['X64', 'ARM64'] : ['X64'], 'debug' => [true, false], 'zts' => [true, false]]
+            : ['include' => [['arch' => $test_arm ? 'ARM64' : 'X64', 'debug' => true, 'zts' => false]]];
+        $jobs['MACOS']['config']['arm64_version'] = version_compare($php_version, '8.4', '>=') ? '15' : '14';
+    }
+    if ($all_jobs || $test_msan) {
+        $jobs['MSAN'] = true;
+    }
+    if ($all_jobs || $test_opcache_variation) {
+        $jobs['OPCACHE_VARIATION'] = true;
+    }
+    if (($all_jobs && $ref === 'master') || $test_pecl) {
+        $jobs['PECL'] = true;
+    }
+    if (version_compare($php_version, '8.6', '>=') && ($all_jobs || $test_solaris)) {
+        $jobs['SOLARIS'] = true;
+    }
+    if ($all_jobs || !$no_jobs || $test_windows) {
+        $jobs['WINDOWS']['matrix'] = $all_variations
+            ? ['include' => [
+                ['asan' => true, 'opcache' => true, 'x64' => true, 'zts' => true],
+                ['asan' => false, 'opcache' => false, 'x64' => false, 'zts' => false],
+            ]]
+            : ['include' => [['asan' => false, 'opcache' => true, 'x64' => true, 'zts' => true]]];
+        $jobs['WINDOWS']['config'] = version_compare($php_version, '8.4', '>=')
+            ? ['vs_crt_version' => 'vs17']
+            : ['vs_crt_version' => 'vs16'];
+    }
+    if ($all_jobs || !$no_jobs || $test_freebsd) {
+        $jobs['FREEBSD']['matrix'] = $all_variations && version_compare($php_version, '8.3', '>=')
+            ? ['zts' => [true, false]]
+            : ['zts' => [false]];
+    }
+    return $jobs;
+}
+
+$trigger = $argv[1] ?? 'schedule';
+$attempt = (int) ($argv[2] ?? 1);
+$sunday = date('w', time()) === '0';
+$discard_cache = $sunday
+    || ($trigger === 'schedule' && $attempt !== 1)
+    || $trigger === 'workflow_dispatch';
+if ($discard_cache) {
+    @unlink(get_branch_commit_cache_file_path());
+}
+$branch = $argv[3] ?? 'master';
+$nightly = $trigger === 'schedule' || $trigger === 'workflow_dispatch';
+$branches = $nightly && $branch === 'master'
+    ? get_branches()
+    : [['name' => 'Suite', 'ref' => $branch, 'version' => get_current_version()]];
+
+$labels = json_decode($argv[4] ?? '[]', true) ?? [];
+$labels = array_column($labels, 'name');
+$all_variations = $nightly || in_array('CI: All variations', $labels, true);
+
+$repository = $argv[5] ?? null;
+
+foreach ($branches as &$branch) {
+    $php_version = $branch['version'][0] . '.' . $branch['version'][1];
+    $branch['jobs'] = select_jobs($repository, $trigger, $nightly, $labels, $php_version, $branch['ref'], $all_variations);
+    $branch['config']['ubuntu_version'] = version_compare($php_version, '8.5', '>=') ? '24.04' : '22.04';
+}
+
+echo "All variations:";
+echo json_encode($all_variations, JSON_UNESCAPED_SLASHES|JSON_PRETTY_PRINT);
+echo "\n\nBranches:\n";
+echo json_encode($branches, JSON_UNESCAPED_SLASHES|JSON_PRETTY_PRINT);
+echo "\n";
+
+if (false !== ($github_output = getenv('GITHUB_OUTPUT'))) {
+    $f = fopen($github_output, 'a');
+    fwrite($f, 'branches=' . json_encode($branches, JSON_UNESCAPED_SLASHES) . "\n");
+    fwrite($f, 'all_variations=' . json_encode($all_variations, JSON_UNESCAPED_SLASHES) . "\n");
+    fclose($f);
+}
diff '--color=auto' -Naur php-8.4.18/.github/nightly_matrix.php php-8.4.20RC1/.github/nightly_matrix.php
--- php-8.4.18/main/debug_gdb_scripts.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/main/debug_gdb_scripts.c	2026-04-01 04:35:36.022662544 +0000
@@ -6,7 +6,7 @@
  *
  * See https://sourceware.org/gdb/current/onlinedocs/gdb.html/dotdebug_005fgdb_005fscripts-section.html#dotdebug_005fgdb_005fscripts-section
  */
-asm(
+__asm__(
     ".pushsection \".debug_gdb_scripts\", \"MS\",%progbits,1\n"
     ".byte 4 /* Python Text */\n"
     ".ascii \"gdb.inlined-script\\n\"\n"
diff '--color=auto' -Naur php-8.4.18/main/fastcgi.c php-8.4.20RC1/main/fastcgi.c
--- php-8.4.18/main/fastcgi.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/main/fastcgi.c	2026-04-01 04:35:36.022801286 +0000
@@ -641,7 +641,7 @@
 
 int fcgi_listen(const char *path, int backlog)
 {
-	char     *s;
+	const char *s;
 	int       tcp = 0;
 	char      host[MAXPATHLEN];
 	short     port = 0;
diff '--color=auto' -Naur php-8.4.18/main/main.c php-8.4.20RC1/main/main.c
--- php-8.4.18/main/main.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/main/main.c	2026-04-01 04:35:36.022970596 +0000
@@ -995,7 +995,7 @@
 {
 	zend_string *replace_origin = NULL;
 	char *docref_buf = NULL, *target = NULL;
-	char *docref_target = "", *docref_root = "";
+	const char *docref_target = "", *docref_root = "";
 	char *p;
 	const char *space = "";
 	const char *class_name = "";
diff '--color=auto' -Naur php-8.4.18/main/network.c php-8.4.20RC1/main/network.c
--- php-8.4.18/main/network.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/main/network.c	2026-04-01 04:35:36.023155495 +0000
@@ -553,7 +553,7 @@
 
 PHPAPI zend_result php_network_parse_network_address_with_port(const char *addr, size_t addrlen, struct sockaddr *sa, socklen_t *sl)
 {
-	char *colon;
+	const char *colon;
 	char *tmp;
 	zend_result ret = FAILURE;
 	short port;
diff '--color=auto' -Naur php-8.4.18/main/php_version.h php-8.4.20RC1/main/php_version.h
--- php-8.4.18/main/php_version.h	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/main/php_version.h	2026-04-01 04:38:20.471143120 +0000
@@ -2,7 +2,8 @@
 /* edit configure.ac to change version number */
 #define PHP_MAJOR_VERSION 8
 #define PHP_MINOR_VERSION 4
-#define PHP_RELEASE_VERSION 18
+#define PHP_RELEASE_VERSION 20
 #define PHP_EXTRA_VERSION ""
-#define PHP_VERSION "8.4.18"
-#define PHP_VERSION_ID 80418
+#define PHP_EXTRA_VERSION "RC1"
+#define PHP_VERSION "8.4.20RC1"
+#define PHP_VERSION_ID 80420
diff '--color=auto' -Naur php-8.4.18/main/php_version.h.orig php-8.4.20RC1/main/php_version.h.orig
--- php-8.4.18/main/streams/filter.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/main/streams/filter.c	2026-04-01 04:35:36.023438721 +0000
@@ -224,7 +224,7 @@
 	const php_stream_filter_factory *factory = NULL;
 	php_stream_filter *filter = NULL;
 	size_t n;
-	char *period;
+	const char *period;
 
 	n = strlen(filtername);
 
@@ -236,17 +236,17 @@
 
 		wildname = safe_emalloc(1, n, 3);
 		memcpy(wildname, filtername, n+1);
-		period = wildname + (period - filtername);
-		while (period && !filter) {
-			ZEND_ASSERT(period[0] == '.');
-			period[1] = '*';
-			period[2] = '\0';
+		char *new_period = wildname + (period - filtername);
+		while (new_period && !filter) {
+			ZEND_ASSERT(new_period[0] == '.');
+			new_period[1] = '*';
+			new_period[2] = '\0';
 			if (NULL != (factory = zend_hash_str_find_ptr(filter_hash, wildname, strlen(wildname)))) {
 				filter = factory->create_filter(filtername, filterparams, persistent);
 			}
 
-			*period = '\0';
-			period = strrchr(wildname, '.');
+			*new_period = '\0';
+			new_period = strrchr(wildname, '.');
 		}
 		efree(wildname);
 	}
diff '--color=auto' -Naur php-8.4.18/main/streams/memory.c php-8.4.20RC1/main/streams/memory.c
--- php-8.4.18/main/streams/memory.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/main/streams/memory.c	2026-04-01 04:35:36.023554028 +0000
@@ -615,7 +615,8 @@
 {
 	php_stream *stream;
 	php_stream_temp_data *ts;
-	char *comma, *semi, *sep;
+	char *comma;
+	const char *semi, *sep;
 	size_t mlen, dlen, plen, vlen, ilen;
 	zend_off_t newoffs;
 	zval meta;
@@ -637,7 +638,7 @@
 		path += 2;
 	}
 
-	if ((comma = memchr(path, ',', dlen)) == NULL) {
+	if ((comma = (char *) memchr(path, ',', dlen)) == NULL) {
 		php_stream_wrapper_log_error(wrapper, options, "rfc2397: no comma in URL");
 		return NULL;
 	}
diff '--color=auto' -Naur php-8.4.18/main/streams/plain_wrapper.c php-8.4.20RC1/main/streams/plain_wrapper.c
--- php-8.4.18/main/streams/plain_wrapper.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/main/streams/plain_wrapper.c	2026-04-01 04:35:36.023672212 +0000
@@ -1775,7 +1775,7 @@
 	ptr = pathbuf;
 
 	while (ptr && *ptr) {
-		end = strchr(ptr, DEFAULT_DIR_SEPARATOR);
+		end = (char *) strchr(ptr, DEFAULT_DIR_SEPARATOR);
 		if (end != NULL) {
 			*end = '\0';
 			end++;
diff '--color=auto' -Naur php-8.4.18/main/streams/xp_socket.c php-8.4.20RC1/main/streams/xp_socket.c
--- php-8.4.18/main/streams/xp_socket.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/main/streams/xp_socket.c	2026-04-01 04:35:36.023811124 +0000
@@ -617,7 +617,7 @@
 
 static inline char *parse_ip_address_ex(const char *str, size_t str_len, int *portno, int get_err, zend_string **err)
 {
-	char *colon;
+	const char *colon;
 	char *host = NULL;
 
 	if (memchr(str, '\0', str_len)) {
@@ -628,7 +628,7 @@
 #ifdef HAVE_IPV6
 	if (*(str) == '[' && str_len > 1) {
 		/* IPV6 notation to specify raw address with port (i.e. [fe80::1]:80) */
-		char *p = memchr(str + 1, ']', str_len - 2);
+		const char *p = memchr(str + 1, ']', str_len - 2);
 		if (!p || *(p + 1) != ':') {
 			if (get_err) {
 				*err = strpprintf(0, "Failed to parse IPv6 address \"%s\"", str);
diff '--color=auto' -Naur php-8.4.18/NEWS.orig php-8.4.20RC1/NEWS.orig
